execute unless entity @s[scores={kb.threshold=0..}] run scoreboard players set @s kb.threshold 100
scoreboard players set @s kb.n_threshold 0
scoreboard players operation @s kb.n_threshold -= @s kb.threshold

scoreboard players set @s kb.press_left 0
scoreboard players set @s kb.press_right 0
scoreboard players set @s kb.press_down 0
scoreboard players set @s kb.press_up 0
scoreboard players set @s kb.press_space 0

scoreboard players set @s kb.release_left 0
scoreboard players set @s kb.release_right 0
scoreboard players set @s kb.release_down 0
scoreboard players set @s kb.release_up 0
scoreboard players set @s kb.release_space 0


execute store result score @s kb.x run data get entity @s Pos[0] 10000
execute store result score @s kb.y run data get entity @s Pos[1] 10000
execute store result score @s kb.z run data get entity @s Pos[2] 10000
execute store result score @s kb.u run data get entity @s Rotation[0] 1
execute store result score @s kb.v run data get entity @s Rotation[1] 1

scoreboard players operation @s kb.x_motion = @s kb.x
scoreboard players operation @s kb.y_motion = @s kb.y
scoreboard players operation @s kb.z_motion = @s kb.z
scoreboard players operation @s kb.u_motion = @s kb.u
scoreboard players operation @s kb.v_motion = @s kb.v

scoreboard players operation @s kb.x_motion -= @s kb.x_prev
scoreboard players operation @s kb.y_motion -= @s kb.y_prev
scoreboard players operation @s kb.z_motion -= @s kb.z_prev
scoreboard players operation @s kb.u_motion -= @s kb.u_prev
scoreboard players operation @s kb.v_motion -= @s kb.v_prev

execute if entity @s[tag=kb.corrected] run function keyboard:correct_motion

execute if score @s kb.z_motion > @s kb.threshold run scoreboard players set @s kb.up 1
execute if score @s kb.z_motion < @s kb.threshold run scoreboard players set @s kb.up 0
execute if entity @s[tag=!kb.press_up,scores={kb.up=1}] run scoreboard players set @s kb.press_up 1
execute if entity @s[tag=!kb.press_up,scores={kb.up=1},tag=debug] run tellraw @a ["",{"text":"[Debug] ","color":"red"},{"selector":"@s","color":"gold"},{"text":" press UP","color":"gold"}]
execute if entity @s[tag=!kb.press_up,scores={kb.up=1}] run tag @s add kb.press_up
execute if entity @s[tag=kb.press_up,scores={kb.up=0}] run scoreboard players set @s kb.release_up 0
execute if entity @s[tag=kb.press_up,scores={kb.up=0},tag=debug] run tellraw @a ["",{"text":"[Debug] ","color":"red"},{"selector":"@s","color":"gold"},{"text":" release UP","color":"gold"}]
execute if entity @s[tag=kb.press_up,scores={kb.up=0}] run tag @s remove kb.press_up


execute if score @s kb.z_motion < @s kb.n_threshold run scoreboard players set @s kb.down 1
execute if score @s kb.z_motion > @s kb.n_threshold run scoreboard players set @s kb.down 0
execute if entity @s[tag=!kb.press_down,scores={kb.down=1}] run scoreboard players set @s kb.press_down 1
execute if entity @s[tag=!kb.press_down,scores={kb.down=1},tag=debug] run tellraw @a ["",{"text":"[Debug] ","color":"red"},{"selector":"@s","color":"gold"},{"text":" press Down","color":"gold"}]
execute if entity @s[tag=!kb.press_down,scores={kb.down=1}] run tag @s add kb.press_down
execute if entity @s[tag=kb.press_down,scores={kb.down=0}] run scoreboard players set @s kb.release_down 0
execute if entity @s[tag=kb.press_down,scores={kb.down=0},tag=debug] run tellraw @a ["",{"text":"[Debug] ","color":"red"},{"selector":"@s","color":"gold"},{"text":" release Down","color":"gold"}]
execute if entity @s[tag=kb.press_down,scores={kb.down=0}] run tag @s remove kb.press_down


execute if score @s kb.x_motion < @s kb.n_threshold run scoreboard players set @s kb.right 1
execute if score @s kb.x_motion > @s kb.n_threshold run scoreboard players set @s kb.right 0
execute if entity @s[tag=!kb.press_right,scores={kb.right=1}] run scoreboard players set @s kb.press_right 1
execute if entity @s[tag=!kb.press_right,scores={kb.right=1},tag=debug] run tellraw @a ["",{"text":"[Debug] ","color":"red"},{"selector":"@s","color":"gold"},{"text":" press Right","color":"gold"}]
execute if entity @s[tag=!kb.press_right,scores={kb.right=1}] run tag @s add kb.press_right
execute if entity @s[tag=kb.press_right,scores={kb.right=0}] run scoreboard players set @s kb.release_right 0
execute if entity @s[tag=kb.press_right,scores={kb.right=0},tag=debug] run tellraw @a ["",{"text":"[Debug] ","color":"red"},{"selector":"@s","color":"gold"},{"text":" release Right","color":"gold"}]
execute if entity @s[tag=kb.press_right,scores={kb.right=0}] run tag @s remove kb.press_right


execute if score @s kb.x_motion > @s kb.threshold run scoreboard players set @s kb.left 1
execute if score @s kb.x_motion < @s kb.threshold run scoreboard players set @s kb.left 0
execute if entity @s[tag=!kb.press_left,scores={kb.left=1}] run scoreboard players set @s kb.press_left 1
execute if entity @s[tag=!kb.press_left,scores={kb.left=1},tag=debug] run tellraw @a ["",{"text":"[Debug] ","color":"red"},{"selector":"@s","color":"gold"},{"text":" press Left","color":"gold"}]
execute if entity @s[tag=!kb.press_left,scores={kb.left=1}] run tag @s add kb.press_left
execute if entity @s[tag=kb.press_left,scores={kb.left=0}] run scoreboard players set @s kb.release_left 0
execute if entity @s[tag=kb.press_left,scores={kb.left=0},tag=debug] run tellraw @a ["",{"text":"[Debug] ","color":"red"},{"selector":"@s","color":"gold"},{"text":" release Left","color":"gold"}]
execute if entity @s[tag=kb.press_left,scores={kb.left=0}] run tag @s remove kb.press_left


execute if score @s kb.y_motion > @s kb.threshold run scoreboard players set @s kb.space 1
execute if score @s kb.y_motion < @s kb.threshold run scoreboard players set @s kb.space 0
execute if entity @s[tag=!kb.press_space,scores={kb.space=1}] run scoreboard players set @s kb.press_space 1
execute if entity @s[tag=!kb.press_space,scores={kb.space=1},tag=debug] run tellraw @a ["",{"text":"[Debug] ","color":"red"},{"selector":"@s","color":"gold"},{"text":" press Space","color":"gold"}]
execute if entity @s[tag=!kb.press_space,scores={kb.space=1}] run tag @s add kb.press_space
execute if entity @s[tag=kb.press_space,scores={kb.space=0}] run scoreboard players set @s kb.release_space 0
execute if entity @s[tag=kb.press_space,scores={kb.space=0},tag=debug] run tellraw @a ["",{"text":"[Debug] ","color":"red"},{"selector":"@s","color":"gold"},{"text":" release Space","color":"gold"}]
execute if entity @s[tag=kb.press_space,scores={kb.space=0}] run tag @s remove kb.press_space



execute if entity @s[tag=kb.fixed] run summon armor_stand ~ ~ ~ {Invisible:1b,NoGravity:1b,CustomName:"{\"text\":\"respawn\"}"} 
execute if entity @s[tag=kb.fixed] store result entity @e[limit=1,name="respawn",type=armor_stand] Pos[0] double 0.0001 run scoreboard players get @s kb.x_prev
execute if entity @s[tag=kb.fixed] store result entity @e[limit=1,name="respawn",type=armor_stand] Pos[1] double 0.0001 run scoreboard players get @s kb.y_prev
execute if entity @s[tag=kb.fixed] store result entity @e[limit=1,name="respawn",type=armor_stand] Pos[2] double 0.0001 run scoreboard players get @s kb.z_prev
execute if entity @s[tag=kb.fixed] store result entity @e[limit=1,name="respawn",type=armor_stand] Rotation[0] float 1 run scoreboard players get @s kb.u_prev
execute if entity @s[tag=kb.fixed] store result entity @e[limit=1,name="respawn",type=armor_stand] Rotation[1] float 1 run scoreboard players get @s kb.v_prev

execute if entity @s[tag=kb.fixed] run tp @s @e[limit=1,name="respawn"]
execute if entity @s[tag=kb.fixed] run kill @e[name="respawn"]


execute if entity @s[tag=!kb.fixed] run scoreboard players operation @s kb.x_prev = @s kb.x
execute if entity @s[tag=!kb.fixed] run scoreboard players operation @s kb.y_prev = @s kb.y
execute if entity @s[tag=!kb.fixed] run scoreboard players operation @s kb.z_prev = @s kb.z
execute if entity @s[tag=!kb.fixed] run scoreboard players operation @s kb.u_prev = @s kb.u
execute if entity @s[tag=!kb.fixed] run scoreboard players operation @s kb.v_prev = @s kb.v